%if 0%{?fedora} > 12
%global with_python3 1
%endif

%global   checkout 1753b9bf044559e18ca1ed39914405a2f8b4fca3
%global   date   20140603

Name: autowrap
Summary: Generates Python Extension modules from [Cython] PXD files
Version: 0.5.0
Release: 4.%{date}git%(echo %{checkout} | cut -c-6)%{?dist}
License: BSD
URL: https://github.com/uweschmitt/autowrap
Source0: https://github.com/uweschmitt/autowrap/archive/%{checkout}.zip#/%{name}-%{checkout}.zip

BuildArch: noarch

BuildRequires: python2-devel, python-setuptools, python-nose, Cython
##Testing
BuildRequires: boost-devel
Requires: Cython

%description
This module uses the Cython "header" .pxd files to automatically generate
Cython input (.pyx) files. It does so by parsing the header files and possibly
annotations in the header files to generate correct Cython code.

%if 0%{?with_python3}
%package -n python3-autowrap
Summary: Generates Python3 Extension modules from [Cython] PXD files

BuildRequires: python3-devel, python3-setuptools, python3-nose, python3-Cython
Requires: python3-Cython

%description -n python3-autowrap
%{summary}.
%endif # with_python3

%prep
%setup -q -n autowrap-%{checkout}

##Remove bundled files
rm -rf autowrap/data_files/boost

%if 0%{?with_python3}
rm -rf %{py3dir}
cp -a . %{py3dir}
%endif # with_python3

%build
%{__python2} setup.py build

%if 0%{?with_python3}
pushd %{py3dir}
%{__python3} setup.py build
popd
%endif # with_python3

%install

# Must do the python3 install first because the scripts in /usr/bin are
# overwritten with every setup.py install (and we want the python2 version
# to be the default for now).
%if 0%{?with_python3}
pushd %{py3dir}
%{__python3} setup.py install --skip-build --root $RPM_BUILD_ROOT
mv $RPM_BUILD_ROOT%{_bindir}/autowrap $RPM_BUILD_ROOT%{_bindir}/python3-autowrap
popd
%endif

%{__python2} setup.py install --skip-build --root $RPM_BUILD_ROOT

%check
export CPPFLAGS="-I%{_includedir}/boost"
export CXXFLAGS="-I%{_includedir}/boost"
nosetests -v -w tests

%if 0%{?with_python3}
%if 0%{?fedora} < 21
pushd %{py3dir}
export CPPFLAGS="-I%{_includedir}/boost"
export CXXFLAGS="-I%{_includedir}/boost"
nosetests-3.3 -v --py3where=tests
popd
%else
pushd %{py3dir}
export CPPFLAGS="-I%{_includedir}/boost"
export CXXFLAGS="-I%{_includedir}/boost"
nosetests-3.4 -v --py3where=tests
popd
%endif # fedora
%endif # with_python3

%files
%doc README* LICENSE
%{_bindir}/autowrap
%{python2_sitelib}/autowrap/
%exclude %{python2_sitelib}/tests/
%{python2_sitelib}/*.egg-info

%if 0%{?with_python3}
%files -n python3-autowrap
%doc README* LICENSE
%{_bindir}/python3-autowrap
%{python3_sitelib}/autowrap/
%exclude %{python3_sitelib}/tests/
%{python3_sitelib}/*.egg-info
%endif

%changelog
* Thu Jul 31 2014 Antonio Trande <sagitterATfedoraproject.org> 0.5.0-4.20140603git1753b9
- Package is now noarch

* Wed Jul 30 2014 Antonio Trande <sagitterATfedoraproject.org> 0.5.0-3.20140603git1753b9
- Fixed BuildRequires and Requires for python3 sub-package
- Removed TODO and CONCEPT files as user documentation

* Wed Jun 11 2014 Antonio Trande <sagitterATfedoraproject.org> 0.5.0-2.20140603git1753b9
- Fixed nosetests command according to new default python3 stack on Fedora 21+

* Thu Jun 05 2014 Antonio Trande <sagitterATfedoraproject.org> 0.5.0-1.20140603git1753b9
- Release 0.5.0

* Mon Jun 02 2014 Antonio Trande <sagitterATfedoraproject.org> 0.4.0-4.20140602gitebde9f
- Update to a new commit (fixed all license headers)

* Mon Jun 02 2014 Antonio Trande <sagitterATfedoraproject.org> 0.4.0-3.20140321git26e901
- Removed conditional macros for EPEL
- Fixed Source0

* Sun Jun 01 2014 Antonio Trande <sagitterATfedoraproject.org> 0.4.0-2.20140321git26e901
- Fixed License
- Fixed Requires package for python2/python3
- Excluded 'tests' directories by packaging
- Performing building operations to packaging independent Python3 module
- Disabled generation of the useless debuginfo package

* Fri May 30 2014 Antonio Trande <sagitterATfedoraproject.org> 0.4.0-1.20140321git26e901
- Initial build
- Fixed Version tag
